<?php

namespace Modules\Qc\Http\Controllers;

use Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Qc\Entities\PackingMaterialChecklist;
use Modules\Qc\Entities\PackingMaterialChecklistHeader;

class PackingMaterialChecklistHeaderController extends Controller
{
    public function allRecords()
    {
        try {
            $query = "SELECT
            qc_packing_material_checklist_headers.*,
            hr_employee_sites.site
        FROM
            hr_employee_sites
            INNER JOIN
            qc_packing_material_checklist_headers
            ON
                hr_employee_sites.site_id = qc_packing_material_checklist_headers.factory
        GROUP BY
            qc_packing_material_checklist_headers.packing_material_id";

            $records = DB::select($query);
            $result = array();
            foreach ($records as $record) {
                array_push($result, [
                    "packing_material_id" => $record->packing_material_id,
                    "reference_no" => $record->reference_no,
                    "factory" => $record->site,
                    "supplier_name" => $record->supplier_name,
                    "date" => $record->date,
                ]);
            }
            $responseBody = $this->responseBody(true, "PackingMaterialChecklistHeaderController", "allRecords", $result);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingMaterialChecklistHeaderController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function deleteRecord($id)
    {
        try {
            if ($this->delete($id)) {
                $rec_data = PackingMaterialChecklistHeader::where('packing_material_id', '=', $id)->get();
                foreach ($rec_data as $data) {
                    $data->delete();
                }
                return true;
            }
        } catch (Exception $exception) {
            return false;
        }
    }

    public function delete($id)
    {
        try {
            $rec_data = PackingMaterialChecklist::where('packing_material_id', '=', $id)->get();
            foreach ($rec_data as $data) {
                $data->delete();
            }
            return true;
        } catch (Exception $exception) {
            return false;
        }
    }


    // public function supervisorCheckListReport($id)
    // {
    //     try {
    //         $query1 = "SELECT
    //         qc_packing_line_quality_record_headers.*,
    //         pp_customer_order_plans_data.manufacturing_order_no,
    //         st_products.product_name,
    //         pp_customer_orders.purchase_order
    //     FROM
    //         qc_packing_line_quality_record_headers
    //         INNER JOIN
    //         st_products
    //         ON
    //             qc_packing_line_quality_record_headers.product_primary_id = st_products.product_primary_id
    //         INNER JOIN
    //         pp_customer_order_plans_data
    //         ON
    //             qc_packing_line_quality_record_headers.customer_order_plan_data_id = pp_customer_order_plans_data.customer_order_plan_data_id
    //         INNER JOIN
    //         pp_customer_orders
    //         ON
    //             qc_packing_line_quality_record_headers.customer_order_plan_data_id = pp_customer_orders.order_id
    //     WHERE
	//         qc_packing_line_quality_record_headers.plqr_id = {$id}";

    //         $records = DB::select($query1);

    //         $header = [
    //             "order_no" => "",
    //             "product" => "",
    //             "factory_order_number" => "",
    //             "trans_date" => "",
    //         ];


    //         if ($records) {
    //             $header["order_no"] = $records[0]->purchase_order;
    //             $header["product"] = $records[0]->product_name;
    //             $header["factory_order_number"] = $records[0]->manufacturing_order_no;
    //             $header["trans_date"] = $records[0]->trans_date;
    //         }

    //         $query2 = "SELECT
    //         qc_packing_line_quality_record_data.*,
    //         hr_employees.name_withinitial
    //     FROM
    //         hr_employees
    //         INNER JOIN
    //         qc_packing_line_quality_record_data
    //         ON
    //             hr_employees.employee_id = qc_packing_line_quality_record_data.checked_by
    //             WHERE
    //             qc_packing_line_quality_record_data.plqr_id = {$id}";

    //         $data = DB::select($query2);

    //         $records[0]->request_data = $data;


    //         $responseBody = $this->responseBody(true, "PackingMaterialChecklistHeaderController", "damageCheckingReport", ["header" => $header, "body" => ["data" => $data]]);
    //     } catch (Exception $exception) {
    //         $responseBody = $this->responseBody(false, "PackingMaterialChecklistHeaderController", "damageCheckingReport", $exception);
    //     }

    //     return response()->json(["data" => $responseBody]);
    // }



     /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }

}
