var TOKEN = Date.now().toString();
var internal_audit_id = null;

$(document).ready(function () {
    $("#myTable").DataTable({
        scrollX: true,
        order: [],
        columns: [
            { data: "Reference No" },
            { data: "Product" },
            { data: "Factory Order No" },
            { data: "Factory" },
            { data: "Description" },
            { data: "Date" },
            { data: "edit", className: "edit", orderable: false },
            { data: "view", className: "view", orderable: false },
            { data: "delete", className: "delete", orderable: false },
        ],
        columnDefs: [
            { width: 30, targets: 6 },
            { width: 30, targets: 7 },
            { width: 30, targets: 8 },
        ],
    });

    $("#attachment_token").val(TOKEN);

    allIaclRecords();
    getOrderNo();
    getProductPrimaryId();
    getFactoryData();

    $("#btnAttachment").on("click", function () {
        $("#attachmentAddModal").modal("toggle");
    });

    $("#btnModalSave").on("click", function () {
        if ($(this).text() === "Save") {
            saveIaclRecord();
        } else {
            updateIaclRecord(internal_audit_id);
        }
    });
});

Dropzone.options.myDropzone = {
    dictDefaultMessage: "Drop file here or click to upload!!!!!!!!",
    addRemoveLinks: true,
    maxFiles: 1,
    init: function () {
        var dropzone = this;
        clearDropzone = function(){
            dropzone.removeAllFiles(true);
        };
    },
};

function allIaclRecords() {
    $.ajax({
        type: "GET",
        url: "/qc/IacListController/records",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            if (response.data.success) {
                var data = [];

                for (i = 0; i < response.data.result.length; i++) {
                    var reference_no = response.data.result[i]["reference_no"];
                    var product_name = response.data.result[i]["product_name"];
                    var manufacturing_order_no =
                        response.data.result[i]["manufacturing_order_no"];
                    var date = response.data.result[i]["date"];
                    var internal_audit_id = response.data.result[i]["internal_audit_id"];
                    var factory = response.data.result[i]["factory"];
                    var description = response.data.result[i]["description"];
                    var path = response.data.result[i]["path"];
                    var pathF = "'" + path + "'";
                    data.push({
                        "Reference No": reference_no,
                        Product: product_name,
                        "Factory Order No": manufacturing_order_no,
                        Factory: factory,
                        Description: description,
                        Date: date,
                        edit:
                            '<button class="btn btn-primary" onclick="edit(' +
                            internal_audit_id +
                            ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        view:
                            '<button class="btn btn-success" onclick="viewAttachment(' +
                            pathF +
                            ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
                        delete:
                            '<button class="btn btn-danger" onclick="_delete(' +
                            internal_audit_id +
                            ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                    });
                }

                var table = $("#myTable").DataTable();
                table.clear();
                table.rows.add(data).draw();
            }
        },

        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function saveIaclRecord() {
    $.ajax({
        type: "POST",
        url: "/qc/IacListController/save",
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            description: $("#description").val(),
            attachment_token: $("#attachment_token").val(),
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                allIaclRecords();
                clearDropzone();
                $("#file_input").val("");
                $("#internal_audit_id").val("");
                $("#attachment_token").val(Date.now().toString());
                $("#reference_no").val("");
                $("#date").val("");
                $("#customer_order_plan_data_id").val("");
                $("#product_primary_id").val("");
                $("#factory").val("");
                $("#description").val("");
                toastr.success("data saved");
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function updateIaclRecord(internal_audit_id) {
    $.ajax({
        type: "PUT",
        url: "/qc/IacListController/update/" + internal_audit_id,
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            description: $("#description").val(),
            attachment_token: $("#attachment_token").val(),
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                allIaclRecords();
                clearDropzone();
                $("#btnModalSave").text("Save");
                $("#file_input").val("");
                $("#attachment_token").val(Date.now().toString());
                $("#internal_audit_id").val("");
                $("#reference_no").val("");
                $("#date").val("");
                $("#customer_order_plan_data_id").val("");
                $("#product_primary_id").val("");
                $("#factory").val("");
                $("#description").val("");
                toastr.success("data updated");
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function edit(id) {
    internal_audit_id = id;
    getIaclData(id);
    $("#btnModalSave").text("Update");
    $("#attachmentAddModal").modal("toggle");
}

function getIaclData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/IacListController/getIaclData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            $("#reference_no").val(res.reference_no);
            $("#date").val(res.date);
            $("#customer_order_plan_data_id").val(
                res.customer_order_plan_data_id
            );
            $("#product_primary_id").val(res.product_primary_id);
            $("#factory").val(res.factory);
            $("#description").val(res.description);
            $("#attachment_token").val(res.token);
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function view(id) {
    location.href = "/qc/internalAudit?id=" + id + "&action=view";
}

function _delete(id) {
    showAlert("Are You Sure?", id);
}

function showAlert(message, id) {
    swal({
        title: message,
        text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: true,
        dangerMode: true,
    });

    $(".swal-button-confirm").on("click", function () {
        $.ajax({
            type: "DELETE",
            headers: {
                "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
            },
            url: "/qc/IacListController/delete/" + id,
            success: function (response) {
                console.log(response);
                allIaclRecords();
            },
            error: function (data) {
                console.log(data);
            },
        });
    });
}

function getFactoryData() {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getFactoryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory").append(
                    '<option value="' +
                    res[i].site_id +
                    '">' +
                    res[i].site +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getOrderNo() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#customer_order_plan_data_id").append(
                    '<option value="' +
                    res[i].customer_order_plan_data_id +
                    '">' +
                    res[i].order_id +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getProductPrimaryId() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getProductPrimaryId",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $("#product_primary_id").append(
                    '<option value="' +
                    res[i].product_primary_id +
                    '">' +
                    res[i].product_name +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}


function viewAttachment(file) {
    window.open('/iac_list/' + file);
}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
